## sfst 1.4.6g

=== src/Makefile ===

# try different definitions of SGILIB if hash_map is not found
#SGILIB=
SGILIB=-DSGI__gnu_cxx
#SGILIB=-DSGIext

# comment the following lines if readline is not found
READLINE = -DREADLINE
ifeq ($(findstring arwin, $(shell uname)),arwin)
LREADLINE = -lreadline -lncurses
else
LREADLINE = -lreadline -lhistory -lncurses
endif

# data type used for the encoding of the symbols (char, short, or int)
# short is the default
#CDT=-DCODE_DATA_TYPE=short

# Uncomment this line in order to compile a library and
# run "make clean" in order to force a recompilation of the object files
# FPIC = -fPIC

CXX = g++
WARNING = -Wall -Wcast-qual -Wconversion -std=c++98 -Wno-deprecated -ansi

ifeq ($(findstring CYGWIN,$(shell uname)),CYGWIN)
EXE = .exe
endif

CC = g++
CL = $(CC)
CFLAGS = -O3 $(WARNING) $(SGILIB) $(CDT) $(READLINE) $(FPIC)
LDFLAGS =

CXXFLAGS = $(CFLAGS)
LXXFLAGS = $(LDFLAGS)

INSTALL = install
INSTALL_MANPAGES = install -m 644
INSTALL_DIR = install -d -m 755

ifeq ($(findstring arwin, $(shell uname)),arwin)
INSTALL_LIBS = $(INSTALL)
else
INSTALL_LIBS = $(INSTALL) -s
endif

DESTDIR =
PREFIX = /usr/local/

PROGRAMS = fst-compiler$(EXE) fst-infl$(EXE) fst-generate$(EXE) fst-print$(EXE)\
	fst-compare$(EXE) fst-compact$(EXE) fst-infl2$(EXE) fst-lowmem$(EXE)\
	fst-infl3$(EXE) fst-lattice$(EXE) fst-match$(EXE) fst-parse$(EXE)\
	fst-parse2$(EXE) fst-train$(EXE) fst-compiler-utf8$(EXE) fst-mor$(EXE) \
	fst-text2bin$(EXE) fst-infl2-daemon$(EXE)

ALLPROGRAMS = $(PROGRAMS)


OBJ = basic.o utf8.o alphabet.o fst.o operators.o determinise.o hopcroft.o

.PHONY: all clean maintainer-clean install maninstall remake

all: $(ALLPROGRAMS)
	strip $(ALLPROGRAMS)

fst-api.zip: testprogram.C alphabet.C alphabet.h basic.C basic.h compact.C \
	compact.h lowmem.C lowmem.h robust.C
	zip $@ $^

fst-compact$(EXE): compact.o make-compact.o

fst-generate$(EXE): generate.o

fst-match$(EXE): compact.o

fst-train$(EXE): compact.o

fst-compiler$(EXE): $(OBJ) compact.o make-compact.o interface.o default-scanner.o

fst-compiler-utf8$(EXE): $(OBJ) compact.o make-compact.o interface.o \
	utf8-scanner.o fst-compiler.o
	$(CXX) -o $@ $^ $(LDFLAGS)

fst-mor$(EXE): $(OBJ) fst-mor.o
	$(CXX) -o $@ $^ $(LDFLAGS) $(LREADLINE)

fst-text2bin$(EXE): $(OBJ) fst-text2bin.o
	$(CXX) -o $@ $^ $(LDFLAGS)

%$(EXE): $(OBJ) %.o
	$(CXX) -o $@ $^ $(LDFLAGS)

fst-infl2$(EXE): alphabet.o basic.o compact.o robust.o utf8.o fst-infl2.o
	$(CXX) -o $@ $^ $(LDFLAGS)

fst-infl2-daemon$(EXE): alphabet.o basic.o compact.o robust.o utf8.o fst-infl2-daemon.o
	$(CXX) -o $@ $^ $(LDFLAGS)

fst-infl3$(EXE): alphabet.o basic.o utf8.o lowmem.o fst-infl3.o
	$(CXX) -o $@ $^ $(LDFLAGS)

testprogram$(EXE): testprogram.o
	$(CL) -lsfst -o $@ $^ $(LDFLAGS) || echo "Note that the SFST library libsfst.so must have been installed in order to compile testprogram."

fst-compiler.C: fst.h compact.h make-compact.h interface.h fst-compiler.yy
	bison -d -o $@ fst-compiler.yy
	if [ -f fst-compiler.C.h ]; then mv fst-compiler.C.h fst-compiler.h; fi
	if [ -f fst-compiler.H ]; then mv fst-compiler.H fst-compiler.h; fi

default-scanner.C: fst.h interface.h scanner.ll fst-compiler.C default-scanner.ll
	flex -o$@ default-scanner.ll

utf8-scanner.C: fst.h interface.h scanner.ll fst-compiler.C utf8-scanner.ll
	flex -o$@ utf8-scanner.ll

default-scanner.ll: scanner.ll
	sed -e '/^utf8>/d' -e 's/^default> *//' scanner.ll > default-scanner.ll

utf8-scanner.ll: scanner.ll
	sed -e '/^default>/d' -e 's/^utf8> *//' scanner.ll > utf8-scanner.ll

libsfst.tar.gz: libsfst.so compact.h alphabet.h basic.h fst.h 
	tar -zcf $@ $^

libsfst.so: alphabet.o basic.o utf8.o compact.o fst.o operators.o determinise.o generate.o hopcroft.o
	$(CL) -shared -o $@ $^ $(LDFLAGS)

libsfst.dylib: alphabet.o basic.o utf8.o compact.o fst.o operators.o determinise.o generate.o hopcroft.o
	$(CL) -dynamiclib -current_version 0 -o $@ $^ $(LDFLAGS)

remake: clean $(ALLPROGRAMS)

clean:
	-rm *.o Makefile.bak y.tab.h man1/*~ 2>&- > /dev/null

maintainer-clean: clean
	-rm $(ALLPROGRAMS) testprogram 2>&- > /dev/null

install: $(PROGRAMS)
	$(INSTALL_DIR) $(DESTDIR)$(PREFIX)bin
	for p in $(PROGRAMS); do $(INSTALL) $$p $(DESTDIR)$(PREFIX)bin/$$p; done

maninstall:
	$(INSTALL_DIR) $(DESTDIR)$(PREFIX)man/man1
	for m in man1/*.1; do $(INSTALL_MANPAGES) $$m $(DESTDIR)$(PREFIX)man/$$m; done

ifeq ($(findstring arwin, $(shell uname)),arwin)
DYNLIBS = libsfst.dylib
else
DYNLIBS = libsfst.so
endif

libinstall: dynlib hfiles

dynlib:	$(DYNLIBS)
	$(INSTALL_LIBS) $^ $(PREFIX)lib
	(ldconfig || true)

hfiles: alphabet.h basic.h fst.h interface.h mem.h sgi.h utf8.h
	-@if [ ! -d $(PREFIX)include/sfst ]; then mkdir -p $(PREFIX)include/sfst; fi
	$(INSTALL) $^ $(PREFIX)include/sfst


# DO NOT DELETE

alphabet.o: utf8.h alphabet.h basic.h sgi.h
basic.o: basic.h
compact.o: compact.h alphabet.h basic.h sgi.h
default-scanner.o: interface.h utf8.h fst.h alphabet.h basic.h sgi.h mem.h
default-scanner.o: fst-compiler.h
determinise.o: fst.h alphabet.h basic.h sgi.h mem.h
fst-compact.o: make-compact.h fst.h alphabet.h basic.h sgi.h mem.h compact.h
fst-compare.o: fst.h alphabet.h basic.h sgi.h mem.h
fst-compiler.o: make-compact.h fst.h alphabet.h basic.h sgi.h mem.h compact.h
fst-compiler.o: interface.h utf8.h
fst-generate.o: fst.h alphabet.h basic.h sgi.h mem.h
fst-infl.o: fst.h alphabet.h basic.h sgi.h mem.h
fst-infl2-daemon.o: Socket.h compact.h alphabet.h basic.h sgi.h
fst-infl2.o: compact.h alphabet.h basic.h sgi.h
fst-infl3.o: lowmem.h alphabet.h basic.h sgi.h
fst-lattice.o: fst.h alphabet.h basic.h sgi.h mem.h
fst-lowmem.o: fst.h alphabet.h basic.h sgi.h mem.h
fst-match.o: compact.h alphabet.h basic.h sgi.h
fst-mor.o: fst.h alphabet.h basic.h sgi.h mem.h
fst-parse.o: fst.h alphabet.h basic.h sgi.h mem.h
fst-parse2.o: fst.h alphabet.h basic.h sgi.h mem.h
fst-print.o: fst.h alphabet.h basic.h sgi.h mem.h
fst-text2bin.o: fst.h alphabet.h basic.h sgi.h mem.h
fst-train.o: compact.h alphabet.h basic.h sgi.h
fst.o: fst.h alphabet.h basic.h sgi.h mem.h
generate.o: fst.h alphabet.h basic.h sgi.h mem.h
interface.o: interface.h utf8.h fst.h alphabet.h basic.h sgi.h mem.h
lowmem.o: lowmem.h alphabet.h basic.h sgi.h
make-compact.o: make-compact.h fst.h alphabet.h basic.h sgi.h mem.h compact.h
operators.o: fst.h alphabet.h basic.h sgi.h mem.h
robust.o: compact.h alphabet.h basic.h sgi.h
testprogram.o: compact.h alphabet.h basic.h sgi.h
utf8-scanner.o: interface.h utf8.h fst.h alphabet.h basic.h sgi.h mem.h
utf8-scanner.o: fst-compiler.h
utf8.o: utf8.h
hopcroft.o: fst.h alphabet.h basic.h sgi.h mem.h

=== debian/changelog ===
sfst (1.4.6g-3) unstable; urgency=low

  * altivec support on powerpcspe (Closes: #701510)
  * fix shlibs-symbol-not-found build warning

 -- Rico Sennrich <rico.sennrich@gmx.ch>  Thu, 9 May 2013 10:15:04 +0100

sfst (1.4.6g-2) unstable; urgency=low

  * bump debhelper version to 9. takes care of some lintian warnings.
  * multi-arch support for shared library
  * set symlink from ChangeLog to NEWS (lintian warning)
  * add lintian override (dev-pkg-without-shlib-symlink)
    shared library has version 1, not 1-1.4

 -- Rico Sennrich <rico.sennrich@gmx.ch>  Mon, 6 May 2013 21:30:04 +0100

sfst (1.4.6g-1) experimental; urgency=low

  * new maintainer (closes: #702488)
  * new upstream release
  * update package style
      * clean-up separation of upstream/debian files
      * use source format 3.0 (quilt)
      * use autoreconf for building
      * add get-orig-source goal to rules (removes PDFs from source tarball)
  * add more headers to dev package 
    (Closes: LP:#583815)
  * fix some lintian warnings
    * fix bad whatis entries of man pages
    * add watch file
    * bump standards to 2.9.4

 -- Rico Sennrich <rico.sennrich@gmx.ch>  Tue, 16 Apr 2013 11:30:57 +0100

sfst (1.2.0-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fix FTBFS with gcc-4.7: rename redeclared variables in src/fst.C
    (Closes: #667372)

 -- Mònica Ramírez Arceda <monica@debian.org>  Mon, 21 May 2012 13:58:07 +0200

sfst (1.2.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build depend on libreadline5-dev to libreadline-dev (Closes: #553852)
  * Set urgency to medium due to RC bug fix
  * Also fix some minor lintian warnings:
    * Add ${misc:Depends} to depends of libsfst1-1.2-0-dev
    * Bump debian/compat to 7
      * Use dh_prep instead of dh_clean -k
    * Bump standards to 2.9.2 (no further changes needed)

 -- Alexander Reichle-Schmehl <tolimar@debian.org>  Fri, 29 Apr 2011 13:46:41 +0200

sfst (1.2.0-1) unstable; urgency=low

  * Initial release Closes: #481915

 -- Francis Tyers <ftyers@prompsit.com>  Mon, 19 May 2008 11:40:31 +0100

=== debian/control ===
Source: sfst
Priority: optional
Maintainer: Rico Sennrich <rico.sennrich@gmx.ch>
Uploaders: Roland Stigge <stigge@antcom.de>
Build-Depends: debhelper (>= 9), dh-autoreconf, pkg-config (>= 0.20 ), flex, bison, libreadline-dev (>= 5.2), libncurses5-dev (>= 5.5)
Standards-Version: 3.9.4
Section: misc
Homepage: http://www.ims.uni-stuttgart.de/projekte/gramotron/SOFTWARE/SFST.html

Package: sfst
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: 
Description: Stuttgart finite-state transducer tools
 SFST is a toolbox for the implementation of morphological analysers 
 and other tools which are based on finite state transducer 
 technology. The SFST tools comprise
 .
   * a compiler which translates transducer programs into minimised transducers
   * interactive and batch-mode analysis programs
   * tools for comparing and printing transducers
   * a C++ library which is efficient and easy to use 
 .

Package: libsfst1-1.4
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Provides: libsfst1
Conflicts: libsfst1
Description: Shared library for SFST
 Contains shared library for SFST. SFST is a toolbox for the 
 implementation of morphological analysers and other tools which are 
 based on finite state transducer technology.
 .

Package: libsfst1-1.4-dev
Section: libdevel
Architecture: any
Depends: libsfst1-1.4 (= ${binary:Version}), ${misc:Depends}
Provides: libsfst1-dev
Conflicts: libsfst1-dev
Description: Development library SFST
 Contains development files for SFST. SFST is a toolbox for the 
 implementation of morphological analysers and other tools which are 
 based on finite state transducer technology.
 .

## sfst 1.4.6h

=== debian/changelog ===
sfst (1.4.6h-1) unstable; urgency=low

  * new upstream release
  * bump standards to 3.9.5
  * fix clang compilation error (closes: #750116)

 -- Rico Sennrich <rico.sennrich@gmx.ch>  Sun, 8 Jun 2014 17:35:54 +0000

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Maintainer: Rico Sennrich <rico.sennrich@gmx.ch>
 Uploaders: Roland Stigge <stigge@antcom.de>
 Build-Depends: debhelper (>= 9), dh-autoreconf, pkg-config (>= 0.20 ), flex, bison, libreadline-dev (>= 5.2), libncurses5-dev (>= 5.5)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Section: misc
-Homepage: http://www.ims.uni-stuttgart.de/projekte/gramotron/SOFTWARE/SFST.html
+Homepage: http://www.cis.uni-muenchen.de/~schmid/tools/SFST/
 
 Package: sfst
 Architecture: any

## sfst 1.4.7b

=== src/Makefile ===
--- 
+++ 
@@ -1,8 +1,3 @@
-
-# try different definitions of SGILIB if hash_map is not found
-#SGILIB=
-SGILIB=-DSGI__gnu_cxx
-#SGILIB=-DSGIext
 
 # comment the following lines if readline is not found
 READLINE = -DREADLINE
@@ -12,6 +7,15 @@
 LREADLINE = -lreadline -lhistory -lncurses
 endif
 
+# The programs will be installed in the subdirectory bin of $DESTDIR
+# The manpages are copied to the subdirectory man of $DESTDIR
+DESTDIR = /usr/local/
+
+# Try different definitions of SGILIB if hash_map is not found
+#SGILIB=
+SGILIB=-DSGI__gnu_cxx
+#SGILIB=-DSGIext
+
 # data type used for the encoding of the symbols (char, short, or int)
 # short is the default
 #CDT=-DCODE_DATA_TYPE=short
@@ -44,9 +48,6 @@
 else
 INSTALL_LIBS = $(INSTALL) -s
 endif
-
-DESTDIR =
-PREFIX = /usr/local/
 
 PROGRAMS = fst-compiler$(EXE) fst-infl$(EXE) fst-generate$(EXE) fst-print$(EXE)\
 	fst-compare$(EXE) fst-compact$(EXE) fst-infl2$(EXE) fst-lowmem$(EXE)\
@@ -138,12 +139,12 @@
 	-rm $(ALLPROGRAMS) testprogram 2>&- > /dev/null
 
 install: $(PROGRAMS)
-	$(INSTALL_DIR) $(DESTDIR)$(PREFIX)bin
-	for p in $(PROGRAMS); do $(INSTALL) $$p $(DESTDIR)$(PREFIX)bin/$$p; done
+	$(INSTALL_DIR) $(DESTDIR)bin
+	for p in $(PROGRAMS); do $(INSTALL) $$p $(DESTDIR)bin/$$p; done
 
 maninstall:
-	$(INSTALL_DIR) $(DESTDIR)$(PREFIX)man/man1
-	for m in man1/*.1; do $(INSTALL_MANPAGES) $$m $(DESTDIR)$(PREFIX)man/$$m; done
+	$(INSTALL_DIR) $(DESTDIR)man/man1
+	for m in man1/*.1; do $(INSTALL_MANPAGES) $$m $(DESTDIR)man/$$m; done
 
 ifeq ($(findstring arwin, $(shell uname)),arwin)
 DYNLIBS = libsfst.dylib

=== debian/changelog ===
sfst (1.4.7b-1) unstable; urgency=medium

  * New upstream release
  * debian/control: Standards-Version: 3.9.6

 -- Roland Stigge <stigge@antcom.de>  Mon, 25 Jan 2016 11:50:52 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Maintainer: Rico Sennrich <rico.sennrich@gmx.ch>
 Uploaders: Roland Stigge <stigge@antcom.de>
 Build-Depends: debhelper (>= 9), dh-autoreconf, pkg-config (>= 0.20 ), flex, bison, libreadline-dev (>= 5.2), libncurses5-dev (>= 5.5)
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Section: misc
 Homepage: http://www.cis.uni-muenchen.de/~schmid/tools/SFST/

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


%:
	dh $@ --with autoreconf

TMP=get-orig-source-tmp
VERSION=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(\([0-9]\+\):\)\?\(.*\)-.*/\3/p')
get-orig-source:
	rm -rf $(TMP)
	mkdir $(TMP)
	uscan --download --no-symlink --destdir $(TMP)
	cd $(TMP) && tar xf SFST*.tar.gz && \
		rm SFST*.tar.gz && \
		rm -r */data && \
		rm -r */doc && \
		tar czf ../sfst_$(VERSION).orig.tar.gz *
	rm -rf $(TMP)

=== debian/watch ===
version=3
ftp://ftp.ims.uni-stuttgart.de/pub/corpora/SFST/SFST-(.+).tar.gz

## sfst 1.5.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
file(STRINGS "VERSION" SFST_VERSION)

project(sfst VERSION ${SFST_VERSION})

message(STATUS "Project name: ${PROJECT_NAME}")
message(STATUS "Project version: ${SFST_VERSION}")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_EXTENSIONS OFF)

# Generate version.h to reflect our version number
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in
               ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h @ONLY)

# add library code
add_subdirectory(src)

# add python bindings
add_subdirectory(python)

=== python/CMakeLists.txt ===
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

set(CMAKE_CXX_FLAGS "-O3 -Wall -std=c++11 -ansi")
set(CMAKE_CXX_FLAGS_RELEASE "-O3")

include(CTest)
find_package(pybind11)
if(pybind11_FOUND)
  message(STATUS "Using system pybind11")
else()
  message(STATUS "No system pybind11, downloading")
  include(pybind11.cmake)
endif()
enable_testing()

set(CPACK_PROJECT_NAME ${PROJECT_NAME})
set(CPACK_PROJECT_VERSION ${PROJECT_VERSION})
include(CPack)

pybind11_add_module(sfst
	sfst.cpp
)
target_compile_definitions(sfst PRIVATE VERSION_INFO=${VERSION_INFO})

target_link_libraries(sfst PRIVATE libsfststatic)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

find_package(FLEX 2.6.4)
find_package(BISON)

set(CMAKE_CXX_FLAGS "-O3 -Wall -std=c++11 -ansi")

include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(.)

if(BISON_FOUND)
    BISON_TARGET(sfst fst-compiler.yy ${CMAKE_CURRENT_BINARY_DIR}/fst-compiler.cpp DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/fst-compiler.h)
else()
    message(STATUS "Bison not found, so executables won't be generated.")
endif()

if(FLEX_FOUND)
    FLEX_TARGET(sfst default-scanner.ll ${CMAKE_CURRENT_BINARY_DIR}/default-scanner.cpp COMPILE_FLAGS --nounput)
    FLEX_TARGET(sfst utf8-scanner.ll ${CMAKE_CURRENT_BINARY_DIR}/utf8-scanner.cpp COMPILE_FLAGS --nounput)
else()
    message(STATUS "Flex not found, so executables won't be generated.")
endif()

# Include dir
include_directories(/usr/local/include)

# Source files
set (LIB_SOURCES
    basic.cpp utf8.cpp alphabet.cpp fst.cpp operators.cpp determinise.cpp hopcroft.cpp
)

set(HEADERS
    alphabet.h basic.h fst.h interface.h mem.h utf8.h ${CMAKE_CURRENT_BINARY_DIR}/fst-compiler.h
)

# Add library
add_library(libsfst SHARED ${LIB_SOURCES})
set_target_properties(libsfst PROPERTIES POSITION_INDEPENDENT_CODE ON)
# Have the output name libsfst.so
set_target_properties(libsfst PROPERTIES OUTPUT_NAME "sfst")

# Have a static library
add_library(libsfststatic STATIC ${LIB_SOURCES})
set_target_properties(libsfststatic PROPERTIES POSITION_INDEPENDENT_CODE ON)
set_target_properties(libsfststatic PROPERTIES OUTPUT_NAME "sfst.static")

if(BISON_FOUND AND FLEX_FOUND)
    add_executable(fst-compiler compact.cpp make-compact.cpp interface.cpp
    default-scanner.cpp fst-compiler.cpp)
    target_link_libraries(fst-compiler libsfst)
    target_link_libraries(fst-compiler readline)

    add_executable(fst-compiler-utf8 compact.cpp make-compact.cpp interface.cpp
    utf8-scanner.cpp fst-compiler.cpp)
    target_link_libraries(fst-compiler-utf8 libsfst)
    target_link_libraries(fst-compiler-utf8 readline)

    add_executable(fst-mor fst-mor.cpp)
    target_link_libraries(fst-mor libsfst)

    add_executable(fst-text2bin fst-text2bin.cpp)
    target_link_libraries(fst-text2bin libsfst)

    add_executable(fst-infl2 fst-infl2.cpp compact.cpp robust.cpp)
    target_link_libraries(fst-infl2 libsfst)

    add_executable(fst-infl2-daemon fst-infl2-daemon.cpp compact.cpp robust.cpp)
    target_link_libraries(fst-infl2-daemon libsfst)

    add_executable(fst-infl3 fst-infl3.cpp lowmem.cpp)
    target_link_libraries(fst-infl3 libsfst)

    add_executable(fst-infl fst-infl.cpp)
    target_link_libraries(fst-infl libsfst)

    add_executable(fst-train fst-train.cpp compact.cpp)
    target_link_libraries(fst-train libsfst)

    add_executable(fst-match fst-match.cpp compact.cpp )
    target_link_libraries(fst-match libsfst)

    add_executable(fst-generate fst-generate.cpp generate.cpp)
    target_link_libraries(fst-generate libsfst)

    add_executable(fst-compact fst-compact.cpp make-compact.cpp compact.cpp)
    target_link_libraries(fst-compact libsfst)

    add_executable(fst-parse fst-parse.cpp)
    target_link_libraries(fst-parse libsfst)

    add_executable(fst-print fst-print.cpp)
    target_link_libraries(fst-print libsfst)

    add_executable(fst-lattice fst-lattice.cpp)
    target_link_libraries(fst-lattice libsfst)

    add_executable(fst-lowmem fst-lowmem.cpp)
    target_link_libraries(fst-lowmem libsfst)


    # Install
    install(TARGETS fst-compact fst-generate fst-infl2 fst-lattice fst-match  fst-parse fst-text2bin fst-compiler fst-compiler-utf8 fst-infl fst-infl3 fst-lowmem fst-mor fst-print fst-train
        RUNTIME DESTINATION bin)
endif()

install(TARGETS libsfst
    RUNTIME DESTINATION lib)

# Install the headers
install(FILES ${HEADERS} DESTINATION include)

file(GLOB_RECURSE SOURCE_FILES *.cpp)

find_program(CLANG_TIDY NAMES clang-tidy)
if (CLANG_TIDY)
    add_custom_target(
        clang-tidy
        COMMAND ${CLANG_TIDY}
        ${SOURCE_FILES}
        --
        -std=c++11
    )
endif ()

=== debian/changelog ===
sfst (1.5.8-2) unstable; urgency=low

  * Team upload

  [ Andreas Tille ]
  * Remove unused patches

  [ Nilesh Patra ]
  * Enable propagation of hardening flags

 -- Andreas Tille <tille@debian.org>  Sun, 18 Aug 2024 07:55:06 +0200

sfst (1.5.8-1) experimental; urgency=low

  * Team upload.
  [ Akshay S Dinesh ]
  * New upstream and new upstream release

  [ Andreas Tille ]
  * Team maintenance by Debian Science team and new maintainer according
    to "RFA: sfst -- Stuttgart finite-state transducer tools" where Akshay
    provided some valuable work on upgrading the package.  I take the quote
      In case I don't come back someone can benefit from these.
    for a chance to let the Debian Science team benefit from these and put
    the package into team maintenance
    Closes: #991815, #843372
  * Add Vcs fields
  * New homepage
  * Fix watch file
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove useless boilerplate in d/rules
  * Drop get-orig-source target since there is no real point in removing
    data and simple PDF docs.
  * Remove old boilerplate from debian/rules (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * debian/control: Remove empty control field Conflicts in package sfst.
  * Remove empty debian/patches/series.
  * Add missing build-dependency on python3-setuptools.
  * Add upstream metadata
  * Add missing Build-Depends
  * No need for debian/*.dirs files
  * Add autopkgtest
  * Attempt to use d-shlibs failed since upstream does not provide static
    library in build system - left d-shlibs call as comment
  * Unversioned *-dev package
  * Fix installation of docs
  * Lintian-override for *.a data file
  * Hardeing options
  * DEP-5 copyright

 -- Andreas Tille <tille@debian.org>  Wed, 07 Aug 2024 15:30:29 +0200

=== debian/control ===
Source: sfst
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Akshay S Dinesh <akshay@learnlearn.in>
Build-Depends: debhelper-compat (= 13),
#               d-shlibs,
               cmake,
               flex,
               bison,
               libreadline-dev,
               python3,
               python3-pybind11,
               python3-setuptools
Standards-Version: 4.7.0
Section: misc
Vcs-Browser: https://salsa.debian.org/science-team/sfst
Vcs-Git: https://salsa.debian.org/science-team/sfst.git
Homepage: https://github.com/santhoshtr/sfst
Rules-Requires-Root: no

Package: sfst
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Stuttgart finite-state transducer tools
 SFST is a toolbox for the implementation of morphological analysers
 and other tools which are based on finite state transducer
 technology. The SFST tools comprise
 .
   * a compiler which translates transducer programs into minimised transducers
   * interactive and batch-mode analysis programs
   * tools for comparing and printing transducers
   * a C++ library which is efficient and easy to use

Package: libsfst1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Replaces: libsfst1-1.4
Conflicts: libsfst1-1.4
Provides: libsfst1-1.4
Description: Shared library for SFST
 Contains shared library for SFST. SFST is a toolbox for the
 implementation of morphological analysers and other tools which are
 based on finite state transducer technology.

Package: libsfst-dev
Section: libdevel
Architecture: any
Depends: libsfst1 (= ${binary:Version}), ${misc:Depends}
Replaces: libsfst1-1.4-dev
Conflicts: libsfst1-1.4-dev
Provides: libsfst1-1.4-dev
Description: Development library SFST
 Contains development files for SFST. SFST is a toolbox for the
 implementation of morphological analysers and other tools which are
 based on finite state transducer technology.

## sfst 1.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.20)
 file(STRINGS "VERSION" SFST_VERSION)
 
 project(sfst VERSION ${SFST_VERSION})
@@ -18,4 +18,5 @@
 add_subdirectory(src)
 
 # add python bindings
+add_subdirectory(pybind11)
 add_subdirectory(python)

=== doc/Makefile ===
default: pdf clean
all: clean pdf clean

pdf: clean SFST-Manual.pdf SFST-Tutorial.pdf

%.pdf: %.tex
	pdflatex $<
clean:
	rm -f *.log *.aux *.bbl *.dvi

=== python/CMakeLists.txt ===
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

set(CMAKE_CXX_FLAGS "-O3 -Wall -std=c++17 -ansi")
set(CMAKE_CXX_FLAGS_RELEASE "-O3")

include(CTest)

enable_testing()

set(CPACK_PROJECT_NAME ${PROJECT_NAME})
set(CPACK_PROJECT_VERSION ${PROJECT_VERSION})
include(CPack)

pybind11_add_module(sfst
	sfst.cpp
)
target_compile_definitions(sfst PRIVATE VERSION_INFO=${VERSION_INFO})

target_link_libraries(sfst PRIVATE libsfststatic)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,12 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.20)
 
-find_package(FLEX 2.6.4)
+list(INSERT CMAKE_MODULE_PATH 0 "${PROJECT_SOURCE_DIR}/src/cmake")
+
+find_package(FLEX)
 find_package(BISON)
+find_package(readline)
 
-set(CMAKE_CXX_FLAGS "-O3 -Wall -std=c++11 -ansi")
+set(CMAKE_CXX_FLAGS "-O3 -Wall -std=c++17 -ansi")
 
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
 include_directories(.)
@@ -19,6 +22,10 @@
     FLEX_TARGET(sfst utf8-scanner.ll ${CMAKE_CURRENT_BINARY_DIR}/utf8-scanner.cpp COMPILE_FLAGS --nounput)
 else()
     message(STATUS "Flex not found, so executables won't be generated.")
+endif()
+
+if(NOT READLINE_FOUND)
+    message(STATUS "Readline not found, so executables won't be generated.")
 endif()
 
 # Include dir
@@ -107,7 +114,7 @@
     RUNTIME DESTINATION lib)
 
 # Install the headers
-install(FILES ${HEADERS} DESTINATION include)
+install(FILES ${HEADERS} DESTINATION include/${PROJECT_NAME})
 
 file(GLOB_RECURSE SOURCE_FILES *.cpp)

=== data/SMOR/Makefile ===

SOURCES = smor.fst
OTHER = lexicon

smor.a: phon.a $(OTHER)

%.a: %.fst
	fst-compiler $< $@

%.ca: %.a
	fst-compact $< $@

Makefile: *.fst
	-makedepend -Y -o.a $(SOURCES) 2>/dev/null 


# DO NOT DELETE

smor.a: map.fst NUM.fst deko.fst flexion.fst defaults.fst FIX.fst PRO.fst

=== data/XMOR/Makefile ===

SOURCES = morph.fst symbols.fst map1.fst map2.fst defaultstems.fst \
	suffixfilter.fst prefixfilter.fst compoundfilter.fst inflection.fst \
	inflectionfilter.fst phon.fst

.PHONY: targets

targets: morph.a

morph.a: phon.a map1.a map2.a prefixfilter.a suffixfilter.a compoundfilter.a \
	inflection.a inflectionfilter.a lexicon

%.a: %.fst
	fst-compiler $< $@

%.ca: %.a
	fst-compact $< $@

archive:
	gtar -zcf VERSION-`date '+%y%m%d'`.tar.gz Makefile lexicon *.fst

clean:
	-rm *.a *~ Makefile.bak 2>&- > /dev/null

Makefile: *.fst
	-makedepend -Y -o.a $(SOURCES) 2>/dev/null 


# DO NOT DELETE

morph.a: symbols.fst defaultstems.fst
map1.a: symbols.fst
map2.a: symbols.fst
suffixfilter.a: symbols.fst
prefixfilter.a: symbols.fst
compoundfilter.a: symbols.fst
inflection.a: symbols.fst
inflectionfilter.a: symbols.fst
phon.a: symbols.fst

=== debian/changelog ===
sfst (1.7.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
    Closes: #1079107
  * Build-Depends: pybind11-dev

 -- Andreas Tille <tille@debian.org>  Thu, 09 Jan 2025 11:42:08 +0100

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
                bison,
                libreadline-dev,
                python3,
+               pybind11-dev,
                python3-pybind11,
                python3-setuptools
 Standards-Version: 4.7.0

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# This has to be exported to make some magic below work.
export DH_OPTIONS

export DH_BUILD_DIR = build
export DH_SOURCE_DIR = .

%:
	dh $@ --buildsystem=cmake --builddirectory=build

# Build system needs to create static and shared library (which means patching cmake files) so we can't use d-shlibs yet
#override_dh_install:
#	dh_install
#	d-shlibmove --commit \
#		    --multiarch \
#		    --devunversioned \
#		    --exclude-la \
#                    --movedev debian/tmp/usr/include usr \
#                    debian/tmp/usr/lib/*/*.so

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/santhoshtr/sfst/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
